/* xhchat
 * Author: Klaus Hartenstein, Uni Karlsruhe, F.R.G.
 * Nov, 1992
 */

/*
  
Copyright (C) 1992 Klaus Hartenstein

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.  This software is provided "as is" without express or
implied warranty.

*/

#include "xhchat.h"

#define WIDTH 500
#define HEIGHT 300

/********************************************************************************/
/* returns the type of the keysym */

int KeyType(keysym, num)
     char *keysym;
     int num;
{
  if(strstr(keysym, "Delete")!=NULL)    return DEL;
  if(strstr(keysym, "BackSpace")!=NULL) return BS;
  if(strstr(keysym, "Return")!=NULL)    return RET;
  if(strstr(keysym, "Left")!=NULL)      return LEFT;
  if(strstr(keysym, "Right")!=NULL)     return RIGHT;
  if(strstr(keysym, "Up")!=NULL)        return UP;
  if(strstr(keysym, "Down")!=NULL)      return DOWN;
  if(Cntrl==True){
    if(keysym[0]=='d') return CTRL_D;    /* del char    */
    if(keysym[0]=='k') return CTRL_K;    /* del to eoln */
    if(keysym[0]=='c') return CTRL_C;    /* exit        */
    return OTHER;
  }
  else
    if(num==0)
      return OTHER;
    else
      return NORM;
}
/********************************************************************************/
/* sets global control-variable */

void SetControl(keysym, mode)
     char *keysym;
     int mode;
{
  if(strstr(keysym, "Control") != NULL){
    if(mode==PRESS)
      Cntrl=True;
    else
      Cntrl=False;
  }
}
/********************************************************************************/
/* adds a char to the widget w at position pos */

AddChar(w, pos, c)
     Widget w;
     XawTextPosition pos;
     char *c;
{
  XawTextBlock txt;
  txt.firstPos=0;
  txt.format=FMT8BIT;
  txt.length=strlen(c);
  txt.ptr=c;
  XawTextReplace(w, pos, pos, &txt);
  XawTextSetInsertionPoint(w, pos+txt.length);
}
/********************************************************************************/
/* deletes the char left to pos */

DeleteCharLeft(w, pos)
     Widget w;
     XawTextPosition pos;
{
  XawTextBlock txt;
  txt.firstPos=0;
  txt.format=FMT8BIT, 
  txt.length=0;
  XawTextReplace(w, pos-1, pos, &txt);
  XawTextSetInsertionPoint(w, pos-1);
}
/********************************************************************************/
/* deletes the char right to pos */

DeleteCharRight(w, pos)
     Widget w;
     XawTextPosition pos;
{
  XawTextBlock txt;
  txt.firstPos=0;
  txt.format=FMT8BIT, 
  txt.length=0;
  XawTextReplace(w, pos, pos+1, &txt);
  XawTextSetInsertionPoint(w, pos);
}
/********************************************************************************/
/* deletes all up to the end of the line in pos */

DeleteLine(w, pos)
     Widget w;
     XawTextPosition pos;
{
  XawTextPosition found;
  XawTextBlock txt1, txt2;
  txt1.firstPos=0;
  txt1.format=FMT8BIT, 
  txt1.length=1;
  txt1.ptr="\n";
  txt2.firstPos=0;
  txt2.format=FMT8BIT, 
  txt2.length=0;
  found=XawTextSearch(w, XawsdRight, &txt1);
  if(found==pos)
    DeleteCharRight(w, pos);
  else if(found!=XawTextSearchError)
    XawTextReplace(w, pos, found, &txt2);
  else
    XawTextReplace(w, pos, 1000000, &txt2);
  XawTextSetInsertionPoint(w, pos);
}
/********************************************************************************/
/* deletes all until the next space */

DeleteWord(w, pos)
     Widget w;
     XawTextPosition pos;
{
  XawTextPosition found;
  XawTextBlock txt1, txt2;
  txt1.firstPos=0;
  txt1.format=FMT8BIT, 
  txt1.length=1;
  txt1.ptr=" ";
  txt2.firstPos=0;
  txt2.format=FMT8BIT, 
  txt2.length=0;
  found=XawTextSearch(w, XawsdRight, &txt1);
  if(found==pos)
    DeleteCharRight(w, pos);
  else if(found!=XawTextSearchError)
    XawTextReplace(w, pos, found, &txt2);
  else
    XawTextReplace(w, pos, 1000000, &txt2);
  XawTextSetInsertionPoint(w, pos);
}
/********************************************************************************/
/* clears the widget w */

void DeleteAll(w)
     Widget w;
{
  XawTextPosition first;
  XawTextBlock txt;
  txt.firstPos=0;
  txt.format=FMT8BIT, 
  txt.length=0;
  first=XawTextTopPosition(w);
  XawTextReplace(w, 0, 100000, &txt);
}
/********************************************************************************/
/* exit program */

void do_quit(w,  client_data,  call_data)
     Widget w;
     XtPointer client_data,  call_data;
{
  XtDestroyApplicationContext(app_con);
  exit(0);
}
/********************************************************************************/
/* toggle wrap mode of textwidgets */

void do_wrap(w,  client_data,  call_data)
     Widget w;
     XtPointer client_data,  call_data;
{
  static Boolean status1=False;
  static Boolean status2=False;
  Boolean *status;
  Widget s, d;
  if((int)client_data == SOURCE1){
    d=drain1;
    s=source1;
    status=(Boolean *)&status1;
  }
  else{
    d=drain2;
    s=source2;
    status=(Boolean *)&status2;
  }
  if(*status==False){
    *status=True;
    XtVaSetValues(s,XtNwrap,XawtextWrapWord,NULL);
    XtVaSetValues(d,XtNwrap,XawtextWrapWord,NULL);
  }
  else{
    *status=False;
    XtVaSetValues(s,XtNwrap,XawtextWrapNever,NULL);
    XtVaSetValues(d,XtNwrap,XawtextWrapNever,NULL);
  }
}
/********************************************************************************/
/* rings the bell */

void do_bell(w,  client_data,  call_data)
     Widget w;
     XtPointer client_data,  call_data;
{
  XBell(d1,0);
  XBell(d2,0);
}
/********************************************************************************/
/* callback to clear all */

void do_clear(w,  client_data,  call_data)
     Widget w;
     XtPointer client_data,  call_data;
{
  Widget s, d;
  if((int)client_data == SOURCE1){
    d=drain2;
    s=source1;
  }
  else{
    d=drain1;
    s=source2;
  }
  DeleteAll(s);
  DeleteAll(d);
}
/********************************************************************************/
/* main event handler for keypresses */

void do_keypress(w, client_data, event)
     Widget w;
     XtPointer client_data;
     XEvent *event;
{
  XComposeStatus compose;
  Widget drain,source;
  char cp[100];
  char keysym[256];
  KeySym ks;
    int i;
  XawTextPosition insert;
  if((w==source1)||(w==drain1)){
    drain=drain2;
    source = source1;
  }
  else{
    drain=drain1;
    source = source2;
  }
  memset(cp, 0, 100);
  insert=XawTextGetInsertionPoint(source);
  if(event->type==2){
    i=XLookupString(&(event->xkey), cp, 100, &ks,&compose);
    if(ks == 0) return;
    strcpy(keysym,XKeysymToString(ks));
    if(i==0)
      SetControl(keysym, PRESS);
    switch(KeyType(keysym, i)){
    case CTRL_D:
      DeleteCharRight(source, insert);
      DeleteCharRight(drain, insert);
      break;
    case CTRL_K:
      DeleteLine(source, insert);
      DeleteLine(drain, insert);
      break;
    case CTRL_C:
      do_quit(NULL,NULL,NULL);
      break;
    case CTRL_P:
      break;
    case CTRL_N:
      break;
    case CTRL_F:
      break;
    case CTRL_B:
      break;
    case RET:
      AddChar(source, insert, "\n");
      AddChar(drain, insert, "\n");
      break;
    case DEL:
      DeleteCharLeft(source, insert);
      DeleteCharLeft(drain, insert);
      break;
    case BS:
      DeleteCharLeft(source, insert);
      DeleteCharLeft(drain, insert);
      break;
    case NORM:
      AddChar(source, insert, cp);
      AddChar(drain, insert, cp);
      break;
    case OTHER:
      break;
    default:
      break;
    }
  }
}
/********************************************************************************/
/* event handler for key release */

void do_keyrelease(w, client_data, event)
     Widget w;
     XtPointer client_data;
     XEvent *event;
{
  XComposeStatus compose;
  
  Widget drain, source;
  XawTextPosition insert;
  int i;
  char keysym[256];
  KeySym ks;
  char cp[100];
  if((w==source1)||(w==drain1)){
    drain=drain2;
    source = source1;
  }
  else{
    drain=drain1;
    source = source2;
  }
  memset(cp, 0, 100);
  i=XLookupString(&(event->xkey), cp, 100, &ks , &compose);
  if(ks != 0){
    strcpy(keysym,XKeysymToString(ks));
    SetControl(keysym, RELEASE);
  }
  insert=XawTextGetInsertionPoint(source);
  XawTextSetInsertionPoint(drain, insert);
}
/********************************************************************************/
void KeyDownAction(w, event, params, num_params)
     Widget w;
     XButtonEvent *event;
     String *params;
     Cardinal num_params;
{
  do_keypress(w,NULL,event);
}
void KeyUpAction(w, event, params, num_params)
     Widget w;
     XButtonEvent *event;
     String *params;
     Cardinal num_params;
{
  do_keyrelease(w,NULL,event);
}
/********************************************************************************/
/* handle buttonpresses */

void do_buttonpress(w, client_data, event)
     Widget w;
     XtPointer client_data;
     XEvent *event;
{
  char *CutBuffer;
  int nbytes;
  int insert;
  Widget drain;
  if(w==source1){
    drain=drain2;
  }
  else{
    drain=drain1;
  }
  if(event->xbutton.button==Button2){
    if((CutBuffer=XFetchBuffer(XtDisplay(w),&nbytes,0)) != NULL){
      insert=XawTextGetInsertionPoint(w);
      AddChar(w,insert,CutBuffer);
      AddChar(drain,insert,CutBuffer);
    }
  }
}
/********************************************************************************/
/* for fututre use */

void do_buttonmotion(w, client_data, event)
     Widget w;
     XtPointer client_data;
     XEvent *event;
{
}
/********************************************************************************/
/* ... */

main(argc, argv)
     int argc;
     char **argv;
{
  Arg args[2];
  int n=0;
  char str[256];
  char *my_disp=(char *)getenv("DISPLAY");
  char *other_disp;
  if(argc<=1)
    other_disp = NULL;
  else
    other_disp = argv[argc-1];
  XtToolkitInitialize();
  
  app_con =  XtCreateApplicationContext();
  XtAppAddActions(app_con,text_actions,XtNumber(text_actions));
  XtAppSetFallbackResources(app_con,fallback_res);
  if((d1 = XtOpenDisplay(app_con,
			 (String) NULL,
			 "xhchat",
			 "Xhchat", 
			 (XrmOptionDescRec *) NULL, (Cardinal)0,
			 (Cardinal *)&argc, (String *) argv))==NULL){
    fprintf(stderr, "Cannot open display: 0.0\n");
    exit(1);
  }
  if((d2 = XtOpenDisplay(app_con,
			 (String)other_disp,
			 "xhchat",
			 "Xhchat",
			 (XrmOptionDescRec *) NULL, (Cardinal)0,
			 (Cardinal *)&argc, (String *)argv))==NULL){
    fprintf(stderr, "Cannot open display %s\n", other_disp);
    exit(1);
  }
  XBell(d1,0);
  XBell(d2,0);
  username=(char *)getenv("USER");
  sprintf(labelstring,"From: %s To: %s",username,d2->display_name);
  /* create shells */
  XtSetArg(args[n],XtNx,100);n++;
  XtSetArg(args[n],XtNy,100);n++;
  top1   = XtAppCreateShell("xhchat",
			    "Xhchat",
			    applicationShellWidgetClass,
			    d1, args, n);
  top2   = XtAppCreateShell("xhchat",
			    "Xhchat",
			    applicationShellWidgetClass,
			    d2, args, n);
  
  lbl_1  =XCreateBitmapFromData(d1,
				RootWindowOfScreen(XtScreen(top1)),
				lbl_bits,
				lbl_width,
				lbl_height);
  lbl_2  =XCreateBitmapFromData(d2,
				RootWindowOfScreen(XtScreen(top2)),
				lbl_bits,
				lbl_width,
				lbl_height);
  paned1 = XtVaCreateManagedWidget("top1", panedWidgetClass,
				   top1, NULL);
  paned2 = XtVaCreateManagedWidget("top2", panedWidgetClass,
				   top2, NULL);
  XtVaSetValues(paned1,XtNshowGrip,False,NULL);    /* shit! */
  XtVaSetValues(paned2,XtNshowGrip,False,NULL);
  /* create cmd-buttons */
  box1   = XtVaCreateManagedWidget("top1", boxWidgetClass, paned1, NULL);
  box2   = XtVaCreateManagedWidget("top2", boxWidgetClass, paned2, NULL);
  cmd    = XtVaCreateManagedWidget("Exit", commandWidgetClass, box1, NULL);
  XtAddCallback(cmd, XtNcallback, do_quit, NULL);
  cmd    = XtVaCreateManagedWidget("Exit", commandWidgetClass, box2, NULL); 
  XtAddCallback(cmd, XtNcallback, do_quit, NULL);
  cmd    = XtVaCreateManagedWidget("Clear", commandWidgetClass, box1, NULL);
  XtAddCallback(cmd, XtNcallback, do_clear, (XtPointer)SOURCE1);
  cmd    = XtVaCreateManagedWidget("Clear", commandWidgetClass, box2, NULL); 
  XtAddCallback(cmd, XtNcallback, do_clear, (XtPointer)SOURCE2);
  cmd    = XtVaCreateManagedWidget("Wrap", toggleWidgetClass, box1, NULL);
  XtAddCallback(cmd, XtNcallback, do_wrap, (XtPointer)SOURCE1);
  cmd    = XtVaCreateManagedWidget("Wrap", toggleWidgetClass, box2, NULL); 
  XtAddCallback(cmd, XtNcallback, do_wrap, (XtPointer)SOURCE2);
  cmd    = XtVaCreateManagedWidget("Bell", commandWidgetClass, box1, NULL); 
  XtAddCallback(cmd, XtNcallback, do_bell, (XtPointer)NULL);
  cmd    = XtVaCreateManagedWidget("Bell", commandWidgetClass, box2, NULL); 
  XtAddCallback(cmd, XtNcallback, do_bell, (XtPointer)NULL);
  cmd    = XtVaCreateManagedWidget("", labelWidgetClass, box1,
				   XtNbitmap,lbl_1,
				   XtNborderWidth,0,NULL); 
  cmd    = XtVaCreateManagedWidget("", labelWidgetClass, box2,
				   XtNbitmap,lbl_2,
				   XtNborderWidth,0,NULL); 
  cmd    = XtVaCreateManagedWidget(labelstring, labelWidgetClass, box1,
				   XtNborderWidth, 0, NULL);
  cmd    = XtVaCreateManagedWidget(labelstring, labelWidgetClass, box2,
				   XtNborderWidth, 0, NULL);
  form1  = XtVaCreateManagedWidget("top1", formWidgetClass, paned1, NULL);
  form2  = XtVaCreateManagedWidget("top2", formWidgetClass, paned2, NULL);
  /* create text-widgets */
  source1= XtVaCreateManagedWidget("source1", asciiTextWidgetClass, 
				   form1, 
				   XtNheight,  HEIGHT,
				   XtNeditType, XawtextEdit, 
				   XtNscrollVertical, XawtextScrollWhenNeeded, 
				   XtNscrollHorizontal, XawtextScrollWhenNeeded, 
				   XtNwidth,  WIDTH, NULL);
  drain1 = XtVaCreateManagedWidget("drain1", asciiTextWidgetClass, 
				   form1, 
				   XtNdisplayNonprinting, True, 
				   XtNfromVert, source1, 
				   XtNeditType, XawtextEdit, 
				   XtNscrollVertical, XawtextScrollWhenNeeded, 
				   XtNscrollHorizontal, XawtextScrollWhenNeeded, 
				   XtNheight,  HEIGHT, 
				   XtNwidth,  WIDTH, NULL);
  source2 =XtVaCreateManagedWidget("source2", asciiTextWidgetClass, 
				   form2, 
				   XtNheight,  HEIGHT, 
				   XtNdisplayNonprinting, True, 
				   XtNeditType, XawtextEdit, 
				   XtNscrollVertical, XawtextScrollWhenNeeded, 
				   XtNscrollHorizontal, XawtextScrollWhenNeeded, 
				   XtNwidth,  WIDTH, NULL);
  drain2 = XtVaCreateManagedWidget("drain2", asciiTextWidgetClass, 
				   form2, 
				   XtNfromVert, source2,
				   XtNdisplayNonprinting, True, 
				   XtNeditType, XawtextEdit, 
				   XtNscrollVertical, XawtextScrollWhenNeeded, 
				   XtNscrollHorizontal, XawtextScrollWhenNeeded, 
				   XtNheight,  HEIGHT, 
				   XtNwidth,  WIDTH, NULL);
  /* delete all translations */
  XtUninstallTranslations(drain1);
  XtUninstallTranslations(drain2);
  XtUninstallTranslations(source1);
  XtUninstallTranslations(source2);

  /* private translations for text-widgets */
  
  XtOverrideTranslations(source1, XtParseTranslationTable(txt_trans));
  XtOverrideTranslations(source2, XtParseTranslationTable(txt_trans));
  XtOverrideTranslations(drain1,  XtParseTranslationTable(drain_txt_trans));
  XtOverrideTranslations(drain2,  XtParseTranslationTable(drain_txt_trans));

  XtVaSetValues(source1,XtNaccelerators,XtParseAcceleratorTable(txt_trans),NULL);
  XtVaSetValues(source2,XtNaccelerators,XtParseAcceleratorTable(txt_trans),NULL);
  XtAddEventHandler(source1, ButtonPressMask, False, do_buttonpress, NULL);
  XtAddEventHandler(source2, ButtonPressMask, False, do_buttonpress, NULL);
  XtInstallAccelerators(form1,source1);
  XtInstallAccelerators(form2,source2);
  XtRealizeWidget(top1);
  XtRealizeWidget(top2);
  XtAppMainLoop(app_con);
}


